SystemOrganization addCategory: #'Fuel-Tests'!
SystemOrganization addCategory: #'Fuel-Core'!
SystemOrganization addCategory: #'Fuel-Core-Cluster'!
SystemOrganization addCategory: #'Fuel-Core-Analyzer'!
SystemOrganization addCategory: #'Fuel-Container'!
SystemOrganization addCategory: #'Fuel-Container-Tests'!

!ByteString methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 15:11'!
fuelAccept: aVisitor

	aVisitor visitPrimitive: self! !

!ByteString methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 13:39'!
fuelSerializer

	^ FLByteStringClusterSerializer instance! !

!ByteSymbol methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 15:12'!
fuelAccept: aVisitor

	aVisitor visitPrimitive: self! !

!ByteSymbol methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 15:13'!
fuelSerializer

	^ FLSymbolClusterSerializer instance! !

!OrderedCollection methodsFor: '*Fuel' stamp: 'MartinDias 10/12/2010 16:11'!
hasAnyDuplicate
	"Answers if there is an element added more than one time"

	^ self size ~= self asSet size ! !

!Bitmap methodsFor: '*Fuel' stamp: 'MartinDias 12/2/2010 13:28'!
fuelSerializer

	^ FLBitmapClusterSerializer instance! !

!SmallInteger methodsFor: '*Fuel' stamp: 'MartinDias 12/28/2010 14:12'!
fuelSerializer

	^ FLSmallIntegerClusterSerializer for: self! !

!CompiledMethod methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 15:33'!
fuelAccept: aVisitor

	aVisitor visitObject: self.! !

!CompiledMethod methodsFor: '*Fuel' stamp: 'MartinDias 10/22/2010 12:56'!
fuelSerializer 

	^ (self isNamedPrimitive)
		ifTrue:  [ FLNamedPrimitiveMethodClusterSerializer instance ]
		ifFalse: [ FLCompiledMethodClusterSerializer instance ]
! !

!CompiledMethod methodsFor: '*Fuel' stamp: 'MartinDias 10/22/2010 12:56'!
isNamedPrimitive 

	^ self primitive = 117! !

!Trait methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 15:23'!
fuelAccept: aVisitor

	aVisitor visitClassOrTrait: self! !

!Behavior methodsFor: '*Fuel' stamp: 'MartinDias 10/12/2010 10:54'!
hasInstanceVariables
	"Returns whether the receiver has instance variables"
	
	^ self instSize > 0 ! !

!UndefinedObject methodsFor: '*Fuel' stamp: 'MartinDias 10/19/2010 10:50'!
fuelAccept: aVisitor

	aVisitor visitNilTrueFalse: self.! !

!UndefinedObject methodsFor: '*Fuel' stamp: 'TristanBourgois 9/24/2010 13:56'!
fuelSerializer 

	^ FLNilTrueFalseClusterSerializer instance! !

!Float methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 15:27'!
fuelAccept: aVisitor

	aVisitor visitPrimitive: self! !

!Float methodsFor: '*Fuel' stamp: 'MartinDias 10/20/2010 22:46'!
fuelSerializer 

	^ FLFloatClusterSerializer instance! !

!Integer methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 15:26'!
fuelAccept: aVisitor

	aVisitor visitPrimitive: self! !

!LargePositiveInteger methodsFor: '*Fuel' stamp: 'TristanBourgois 9/24/2010 14:21'!
fuelSerializer 

	^ FLLargePositiveIntegerClusterSerializer instance.! !

!Character methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 15:28'!
fuelAccept: aVisitor

	aVisitor visitPrimitive: self! !

!Character methodsFor: '*Fuel' stamp: 'MartinDias 9/23/2010 17:41'!
fuelSerializer

	^ FLCharacterClusterSerializer instance! !

TestCase subclass: #FLClusterSerializerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Tests'!

!FLClusterSerializerTest methodsFor: 'tests' stamp: 'MartinDias 10/12/2010 16:10'!
testUniqueIds

	" 
	Inspect the mapping:
	FLClusterSerializer allSubclasses collect: [ :aClass | aClass->([aClass id] ifError: [nil]) ]
	"

	self shouldnt: [ FLClusterSerializer validateIdDistribution ] raise: Error! !

TestCase subclass: #FLContainerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Container-Tests'!

!FLContainerTest methodsFor: 'running' stamp: 'MartinDias 2/26/2011 02:52'!
readerVersion1
	| reader |
	reader := FLContainerReader new.
	reader materializers at: 1 put: self sampleMaterializer.
	reader signature: self sampleSignature.
	^ reader! !

!FLContainerTest methodsFor: 'running' stamp: 'MartinDias 2/26/2011 03:33'!
readerVersion2
	| reader |
	reader := self readerVersion1.
	reader materializers at: 2 put: self sampleMaterializer.
	^ reader 
		signature: self sampleSignature;
		yourself
! !

!FLContainerTest methodsFor: 'running' stamp: 'MartinDias 2/25/2011 21:19'!
sampleContent
	^ 'SampleContent'! !

!FLContainerTest methodsFor: 'running' stamp: 'MartinDias 2/25/2011 23:33'!
sampleMaterializer
	^ [ :aStream | aStream nextString ]! !

!FLContainerTest methodsFor: 'running' stamp: 'MartinDias 2/25/2011 23:31'!
sampleSerializer
	^ [ :aStream :anObject | aStream nextStringPut: anObject ]! !

!FLContainerTest methodsFor: 'running' stamp: 'MartinDias 2/25/2011 23:37'!
sampleSignature
	^ 'FLM' asByteArray! !

!FLContainerTest methodsFor: 'running' stamp: 'MartinDias 2/25/2011 20:20'!
stream
	^ (RWBinaryOrTextStream on: '') binary! !

!FLContainerTest methodsFor: 'tests' stamp: 'MartinDias 2/26/2011 03:30'!
testBadSignature

	| aStream |
	aStream := self stream.
	self writerStrangeSignature on: aStream nextPut: self sampleContent.
	self should: [ self readerVersion1 nextOn: aStream reset ] raise: Error.
	! !

!FLContainerTest methodsFor: 'tests' stamp: 'MartinDias 2/26/2011 03:30'!
testBadVersion

	| aStream |
	aStream := self stream.
	self writerVersion2 on: aStream nextPut: self sampleContent.
	self should: [ self readerVersion1 nextOn: aStream reset ] raise: Error.
	! !

!FLContainerTest methodsFor: 'tests' stamp: 'MartinDias 2/26/2011 03:31'!
testOldVersionSuccess

	| aStream written read |
	aStream := self stream.
	written := self sampleContent.
	self writerVersion1 on: aStream nextPut: written.
	read := self readerVersion2 nextOn: aStream reset.
	self assert: written equals: read.! !

!FLContainerTest methodsFor: 'tests' stamp: 'MartinDias 2/26/2011 03:21'!
testSuccess

	| aStream written read |
	aStream := self stream.
	written := self sampleContent.
	self writerVersion1 on: aStream nextPut: written.
	read := self readerVersion1 nextOn: aStream reset.
	self assert: written equals: read.! !

!FLContainerTest methodsFor: 'running' stamp: 'MartinDias 2/26/2011 02:57'!
writerStrangeSignature
	^ self writerVersion1
		signature: #[0 0 0];
		yourself.! !

!FLContainerTest methodsFor: 'running' stamp: 'MartinDias 2/25/2011 23:39'!
writerVersion1
	| writer |
	writer := FLContainerWriter new.
	writer serializers at: 1 put: self sampleSerializer.
	^ writer 
		signature: self sampleSignature;
		currentVersion: 1;
		yourself! !

!FLContainerTest methodsFor: 'running' stamp: 'MartinDias 2/25/2011 23:31'!
writerVersion2
	| writer |
	writer := self writerVersion1.
	writer serializers at: 2 put: self sampleSerializer.
	writer currentVersion: 2.
	^ writer
! !

TestCase subclass: #FLSerializationTest
	instanceVariableNames: 'temporaryFiles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Tests'!

!FLSerializationTest commentStamp: '<historical>' prior: 0!
I have black-box tests for testing that objects serializes and materializes well.!

FLSerializationTest subclass: #FLBasicSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Tests'!

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/25/2010 14:24'!
testArray
	self assertSerializationEqualityOf: #(10 20)! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/25/2010 14:27'!
testByteArrays

	self assertSerializationEqualityOf: { #[1 2 3 4 5 6]. #[1 2 3 4 5 6]. #[7 8 9 10 11 12]. #[7 8 9 10 11 12] }! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 21:00'!
testCharacter

	self assertSerializationIdentityOf: $a! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 11/11/2010 19:31'!
testCyclicLinks

	| a b c materializedA |
	a := Link new.
	b := Link new.
	c := Link new.
	
	a nextLink: b.
	b nextLink: c.
	c nextLink: a.
	
	materializedA := self resultOfSerializeAndMaterialize: a.

	"We can't check using the equality of the links because hangs ad infinitum. So we only check that the structure is right."
	self assert: materializedA nextLink nextLink nextLink == materializedA.
	self deny: materializedA nextLink == materializedA.
	self deny: materializedA nextLink nextLink == materializedA.! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 20:59'!
testDictionary

	self assertSerializationEqualityOf: (Dictionary with: 1->2).! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/26/2010 19:46'!
testEmptyArray
	self assertSerializationEqualityOf: #()! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/26/2010 19:45'!
testEmptyDictionary

	self assertSerializationEqualityOf: Dictionary new! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/26/2010 19:46'!
testEmptyOrderedCollection

	self assertSerializationEqualityOf: OrderedCollection new! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 20:59'!
testFalse

	self assertSerializationIdentityOf: false! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/21/2010 10:49'!
testFloat
	
	self assertSerializationEqualityOf: 180.0! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 12/2/2010 13:01'!
testGradientFillStyle
	self assertSerializationEqualityOf: GradientFillStyle sample! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 20:54'!
testLargeNegativeInteger

	self assertSerializationEqualityOf: -354314316134313999999999.! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 20:54'!
testLargePositiveInteger

	self assertSerializationEqualityOf: 354314316134313999999999.! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 20:56'!
testNil

	self assertSerializationIdentityOf: nil! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/29/2010 11:27'!
testOrderedCollection

	self assertSerializationEqualityOf: (OrderedCollection with: 10 with: 20)! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 11/25/2010 18:40'!
testPair

	self assertSerializationEqualityOf:
			(FLPair new
				left: 10;
				right: 20;
				yourself)! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 20:57'!
testPoint

	self assertSerializationEqualityOf: 10@20! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/26/2010 14:57'!
testRectangle
	
	self assertSerializationEqualityOf: (10@20 corner: 30@40)! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 20:57'!
testSmallInteger

	self assertSerializationIdentityOf: SmallInteger one.! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 20:57'!
testSmallIntegerMaxValue

	self assertSerializationIdentityOf: SmallInteger maxVal .
	! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 21:04'!
testSmallIntegerMinValue

	self assertSerializationIdentityOf: SmallInteger minVal ! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 9/29/2010 11:27'!
testSmallIntegerNegative

	self assertSerializationIdentityOf: -42.! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/19/2010 14:47'!
testSmalltalkGlobal

	self assertSerializationIdentityOf: Transcript! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/18/2010 12:23'!
testSmalltalkGlobalAssociation

	self assertSerializationIdentityOf: (Smalltalk associationAt: #Transcript)! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 20:58'!
testString

	self assertSerializationEqualityOf: 'testString'! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 20:58'!
testSymbol

	self assertSerializationIdentityOf: #testSymbol! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 20:59'!
testTrue

	self assertSerializationIdentityOf: true! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 12/1/2010 16:49'!
testWordArray
	self assertSerializationEqualityOf: (WordArray with: 10 with: 20)! !

!FLBasicSerializationTest methodsFor: 'tests' stamp: 'MartinDias 12/1/2010 16:52'!
testWordArrayForSegment 
	self assertSerializationEqualityOf: (WordArrayForSegment with: 1929386344 with: 214577675)! !

FLSerializationTest subclass: #FLClassSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Tests'!

!FLClassSerializationTest methodsFor: 'running' stamp: 'MartinDias 11/11/2010 19:53'!
stubClassName

	^ #FLTemporaryPair! !

!FLClassSerializationTest methodsFor: 'running' stamp: 'MartinDias 11/11/2010 23:56'!
stubClassWithInstanceVars: instanceVariableNames

	^ Object subclass: self stubClassName 
		instanceVariableNames: instanceVariableNames
		classVariableNames: ''
		poolDictionaries: ''
		category: self class category.
! !

!FLClassSerializationTest methodsFor: 'running' stamp: 'MartinDias 2/15/2011 12:04'!
tearDown

	super tearDown.
	(Smalltalk hasClassNamed: self stubClassName) 
		ifTrue: [Smalltalk removeClassNamed: self stubClassName]! !

!FLClassSerializationTest methodsFor: 'tests' stamp: 'MartinDias 11/25/2010 18:41'!
testReferencedClass
	"Tests the serialization of a class that is not being exported"
	
	self assertSerializationIdentityOf: FLPair! !

!FLClassSerializationTest methodsFor: 'tests' stamp: 'MartinDias 11/25/2010 18:41'!
testReferencedMetaclass
	"Tests the serialization of a Metaclass that is not being exported"
	
	self assertSerializationIdentityOf: FLPair class! !

!FLClassSerializationTest methodsFor: 'tests' stamp: 'MartinDias 11/11/2010 20:58'!
testReferencedTrait
	"Tests the serialization of a trait that is not being exported"
	
	self assertSerializationIdentityOf: TPureBehavior! !

!FLClassSerializationTest methodsFor: 'tests' stamp: 'MartinDias 11/11/2010 20:57'!
testVariableInsertion
	"Tests that serializer tolarates when there is a new instance variable on materialization"
	
	| stream aPair resultPair |	

	aPair := (self stubClassWithInstanceVars: 'left right') new.
	aPair instVarAt: 1 put: $A.	
	aPair instVarAt: 2 put: $B.	
	stream := self serializationOf: aPair.
	
	self stubClassWithInstanceVars: 'left middle right'.
	resultPair := self materializationOn: stream reset.
	self assert: $A equals: (resultPair instVarAt: 1).
	self assert: nil equals: (resultPair instVarAt: 2).	
	self assert: $B equals: (resultPair instVarAt: 3).	! !

!FLClassSerializationTest methodsFor: 'tests' stamp: 'MartinDias 11/11/2010 20:01'!
testVariableOrderChange
	"Tests that serializer tolarates when the order in the instance variables changed between serialization and materialization"
	
	| pairClass stream aPair resultPair |	

	pairClass := self stubClassWithInstanceVars: 'left right'.
	aPair := pairClass new.
	aPair instVarAt: 1 put: $A.	
	aPair instVarAt: 2 put: $B.	
	stream := self serializationOf: aPair.
	
	pairClass := self stubClassWithInstanceVars: 'right left'.
	resultPair := self materializationOn: stream reset.
	self assert: $B equals: (resultPair instVarAt: 1).
	self assert: $A equals: (resultPair instVarAt: 2).	! !

!FLClassSerializationTest methodsFor: 'tests' stamp: 'MartinDias 11/11/2010 20:58'!
testVariableRemoved
	"Tests that serializer tolarates when an instance variable is missing on materialization"
	
	| stream aPair resultPair |	

	aPair := (self stubClassWithInstanceVars: 'left right') new.
	aPair instVarAt: 1 put: $A.	
	aPair instVarAt: 2 put: $B.	
	stream := self serializationOf: aPair.
	
	self stubClassWithInstanceVars: 'right'.
	resultPair := self materializationOn: stream reset.
	self assert: $B equals: (resultPair instVarAt: 1).	! !

FLSerializationTest subclass: #FLCompiledMethodSerializationTest
	instanceVariableNames: 'instanceVarForTesting'
	classVariableNames: 'ClassVariableForTesting'
	poolDictionaries: ''
	category: 'Fuel-Tests'!

FLCompiledMethodSerializationTest class
	instanceVariableNames: 'classInstanceVariableForTesting'!

FLCompiledMethodSerializationTest class
	instanceVariableNames: 'classInstanceVariableForTesting'!

!FLCompiledMethodSerializationTest classSide methodsFor: 'testing' stamp: 'MartinDias 10/7/2010 11:53'!
classInstanceVariableForTesting
	^ classInstanceVariableForTesting! !

!FLCompiledMethodSerializationTest classSide methodsFor: 'testing' stamp: 'MartinDias 10/7/2010 11:54'!
classInstanceVariableForTesting: anObject
	
	classInstanceVariableForTesting := anObject! !

!FLCompiledMethodSerializationTest methodsFor: 'running' stamp: 'MartinDias 10/18/2010 14:08'!
atInstanceVarForTestingPut: anObject
	
	instanceVarForTesting := anObject ! !

!FLCompiledMethodSerializationTest methodsFor: 'running' stamp: 'MartinDias 10/18/2010 14:08'!
classVariableForTesting
	
	^ ClassVariableForTesting! !

!FLCompiledMethodSerializationTest methodsFor: 'running' stamp: 'MartinDias 10/18/2010 14:08'!
classVariableForTesting: anObject
	
	ClassVariableForTesting := anObject ! !

!FLCompiledMethodSerializationTest methodsFor: 'running' stamp: 'MartinDias 10/18/2010 14:08'!
fortyTwo
	^ 42 ! !

!FLCompiledMethodSerializationTest methodsFor: 'running' stamp: 'MartinDias 10/18/2010 14:08'!
fortyTwoBlockClosure
	^ [ self fortyTwo ] ! !

!FLCompiledMethodSerializationTest methodsFor: 'running' stamp: 'MartinDias 10/20/2010 14:56'!
globalVariableForTesting

	^ Smalltalk globals at: #FLGlobalVariableForTesting ! !

!FLCompiledMethodSerializationTest methodsFor: 'running' stamp: 'MartinDias 10/20/2010 14:56'!
globalVariableForTesting: anObject

	 Smalltalk globals at: #FLGlobalVariableForTesting put: anObject! !

!FLCompiledMethodSerializationTest methodsFor: 'running' stamp: 'MartinDias 11/26/2010 17:00'!
materializedCompiledMethod: aCompiledMethod

	| materializedCompiledMethod |
	materializedCompiledMethod := self resultOfSerializeAndMaterialize: aCompiledMethod.
	
	self deny: aCompiledMethod == materializedCompiledMethod.

	"CompiledMethod>>= is too strict for us, so we check equality in this way"

	self flag: #todo. "fix ugly code"
	self assert: aCompiledMethod getSource asString withBlanksTrimmed 
		equals: materializedCompiledMethod getSource asString withBlanksTrimmed.

	self deny: aCompiledMethod getSource == materializedCompiledMethod getSource.

	self assert: aCompiledMethod header equals: materializedCompiledMethod header.

	self assert: aCompiledMethod initialPC equals: materializedCompiledMethod initialPC.

	self assert: aCompiledMethod size equals: materializedCompiledMethod size.

	^ materializedCompiledMethod! !

!FLCompiledMethodSerializationTest methodsFor: 'running' stamp: 'MartinDias 10/21/2010 13:53'!
tearDown

	super tearDown.
	Smalltalk globals removeKey: #FLGlobalVariableForTesting ifAbsent: []! !

!FLCompiledMethodSerializationTest methodsFor: 'tests' stamp: 'MartinDias 11/11/2010 17:46'!
testBasicMethod

	| materializedCompiledMethod |

	materializedCompiledMethod := self materializedCompiledMethod: Object >> #yourself.

	self assert: self == (materializedCompiledMethod valueWithReceiver: self arguments: #()).! !

!FLCompiledMethodSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 21:22'!
testBlockClosureMethod

	| materializedCompiledMethod |

	materializedCompiledMethod := self materializedCompiledMethod: self class >> #fortyTwoBlockClosure.

	self assert: 42 equals: (materializedCompiledMethod valueWithReceiver: self arguments: #()) value
! !

!FLCompiledMethodSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 21:24'!
testClassInstanceVariableMethod

	| materializedCompiledMethod |

	materializedCompiledMethod := self materializedCompiledMethod: self class class >> #classInstanceVariableForTesting:.

	self class classInstanceVariableForTesting: false.
	materializedCompiledMethod valueWithReceiver: self class arguments: { true }.
	self assert: self class classInstanceVariableForTesting.! !

!FLCompiledMethodSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 21:31'!
testClassVariableMethod

	| materializedCompiledMethod |

	materializedCompiledMethod := self materializedCompiledMethod: self class >> #classVariableForTesting:.

	self classVariableForTesting: false.
	materializedCompiledMethod valueWithReceiver: self arguments: { true }.
	self assert: self classVariableForTesting.! !

!FLCompiledMethodSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 21:32'!
testGlobalVariableMethod

	| materializedCompiledMethod |

	materializedCompiledMethod := self materializedCompiledMethod: self class >> #globalVariableForTesting:.
	
	self globalVariableForTesting: false.
	materializedCompiledMethod valueWithReceiver: self arguments: { true }.
	self assert: self globalVariableForTesting.! !

!FLCompiledMethodSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/26/2010 14:57'!
testInstanceVariableMethod

	| materializedCompiledMethod |

	materializedCompiledMethod := self materializedCompiledMethod: self class >> #atInstanceVarForTestingPut:.

	instanceVarForTesting := false.
	materializedCompiledMethod valueWithReceiver: self arguments: { true }.
	self assert: instanceVarForTesting.! !

!FLCompiledMethodSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/22/2010 12:19'!
testNamedPrimitiveMethod

	| materializedCompiledMethod |

	materializedCompiledMethod := self materializedCompiledMethod: Integer >> #bitAnd:.

	self assert: 16r30 equals: (materializedCompiledMethod valueWithReceiver: 16r3F arguments: #(16rF0)).! !

!FLCompiledMethodSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 21:35'!
testPrimitiveMethod

	| materializedCompiledMethod |

	materializedCompiledMethod := self materializedCompiledMethod: Object >> #perform:.

	self assert: 42 equals: (materializedCompiledMethod valueWithReceiver: self arguments: #(fortyTwo)).! !

!FLCompiledMethodSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/17/2010 21:35'!
testSmallIntegerMethod

	| materializedCompiledMethod |

	materializedCompiledMethod := self materializedCompiledMethod: self class >> #fortyTwo.

	self assert: 42 equals: (materializedCompiledMethod valueWithReceiver: self arguments: #()).! !

FLSerializationTest subclass: #FLCrowdedSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Tests'!

!FLCrowdedSerializationTest commentStamp: '<historical>' prior: 0!
I have tests with large samples, so I'm very slow to be run frequently.!

!FLCrowdedSerializationTest methodsFor: 'tests' stamp: 'MartinDias 10/28/2010 12:04'!
testLotsOfIntegers

	| integers |
	integers := Set new.
	1 to: (2 raisedTo: 17) do: [ :index | integers add: index ].

	self assertSerializationEqualityOf: integers! !

!FLSerializationTest methodsFor: 'running' stamp: 'MartinDias 11/11/2010 19:31'!
assertSerializationEqualityOf: anObject
	"Asserts that the original object and the materialized one are equal (but not the same)"

	| materialized |
	materialized := self resultOfSerializeAndMaterialize: anObject.
	self should: [ anObject ~~ materialized ].
	self assert: anObject equals: materialized! !

!FLSerializationTest methodsFor: 'running' stamp: 'MartinDias 11/11/2010 19:31'!
assertSerializationIdentityOf: anObject
	"Asserts that the original object and the materialized one are the same"

	self should: [ anObject == (self resultOfSerializeAndMaterialize: anObject)  ]! !

!FLSerializationTest methodsFor: 'running' stamp: 'MartinDias 11/25/2010 19:23'!
materializationOn: aStream
	"Returns the result of materializing aStream."

	^ (self materializerOn: aStream)
		materialize;
		root! !

!FLSerializationTest methodsFor: 'running' stamp: 'MartinDias 11/25/2010 19:23'!
materializerOn: aStream

	^ FLMaterializer on: aStream! !

!FLSerializationTest methodsFor: 'running' stamp: 'MartinDias 11/11/2010 19:31'!
resultOfSerializeAndMaterialize: anObject
	"Returns the result of serializing and materializing anObject."

	| stream |

	stream := self serializationOf: anObject.
	^ self materializationOn: stream reset


"	Using ReferenceStream:
	
	| stream |

	stream := ReferenceStream on: (RWBinaryOrTextStream on: '') binary.
	stream nextPut: anObject.

	stream := ReferenceStream on:  stream contents readStream.
	^ stream next"! !

!FLSerializationTest methodsFor: 'running' stamp: 'MartinDias 11/11/2010 19:33'!
serializationOf: anObject
	"Returns the result of serializing anObject."

	^ (self serializer serialize: anObject) stream! !

!FLSerializationTest methodsFor: 'running' stamp: 'MartinDias 11/11/2010 19:18'!
serializer

	^ FLSerializer on: self writeStream! !

!FLSerializationTest methodsFor: 'running' stamp: 'MartinDias 2/15/2011 12:22'!
setUp

	super setUp.
	temporaryFiles := OrderedCollection new.! !

!FLSerializationTest methodsFor: 'running' stamp: 'MartinDias 2/15/2011 12:18'!
tearDown

	super tearDown.
	temporaryFiles do: [ :aFile | aFile close ].! !

!FLSerializationTest methodsFor: 'running' stamp: 'MartinDias 2/15/2011 12:18'!
writeStream 

"	^ (RWBinaryOrTextStream on: '') binary"
	^ temporaryFiles add: (StandardFileStream forceNewFileNamed: 'testTmp.fuel') binary! !

!Boolean methodsFor: '*Fuel' stamp: 'MartinDias 10/19/2010 10:50'!
fuelAccept: aVisitor

	aVisitor visitNilTrueFalse: self.! !

!Boolean methodsFor: '*Fuel' stamp: 'MartinDias 9/27/2010 09:15'!
fuelSerializer 

	^ FLNilTrueFalseClusterSerializer instance ! !

!Class methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 15:23'!
fuelAccept: aVisitor

	aVisitor visitClassOrTrait: self! !

!ByteArray methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 15:06'!
fuelAccept: aVisitor

	aVisitor visitPrimitive: self! !

!ByteArray methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 14:38'!
fuelSerializer 

	^ FLByteArrayClusterSerializer instance! !

!LargeNegativeInteger methodsFor: '*Fuel' stamp: 'TristanBourgois 9/24/2010 15:09'!
fuelSerializer 

	^ FLLargeNegativeIntegerClusterSerializer instance.! !

!Metaclass methodsFor: '*Fuel' stamp: 'MartinDias 10/19/2010 10:50'!
fuelAccept: aVisitor

	aVisitor visitMetaclass: self! !

!Metaclass methodsFor: '*Fuel' stamp: 'MartinDias 10/5/2010 10:58'!
fuelSerializer 
	^ FLMetaclassClusterSerializer instance.! !

Object subclass: #FLAnalyzer
	instanceVariableNames: 'objectCount analyzers clusteredMetalevelObjects clusteredBaselevelObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Analyzer'!

!FLAnalyzer commentStamp: '<historical>' prior: 0!
I am responsible of traverse the graph of references starting on a collection of root objects. I will produce dictionaries that associate each traversed object to a serializer.

An example of use is

	FLAnalyzer newDefault 
		analyzeAll: { 1@2. 3@4 };
		clusteredInstances.
	
The results are used by FLSerializer to serialize the analyzed objects into a stream.!

!FLAnalyzer class methodsFor: 'instance creation' stamp: 'MartinDias 10/26/2010 10:32'!
new

	self error: 'Should use an specific instance creation message.'! !

!FLAnalyzer class methodsFor: 'instance creation' stamp: 'MartinDias 10/26/2010 10:31'!
newDefault

	^ self basicNew 
		initialize; 
		initializeDefaultAnalyzers;
		yourself! !

!FLAnalyzer methodsFor: 'analyze' stamp: 'MartinDias 10/25/2010 15:07'!
analyze: anObject

	(self analyzerFor: anObject) value: anObject ! !

!FLAnalyzer methodsFor: 'protected' stamp: 'MartinDias 10/26/2010 10:35'!
analyzerFor: anObject

	^ analyzers detect: [ :anAnalyzer | anAnalyzer analyzes: anObject ].
! !

!FLAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 11/3/2010 14:58'!
clusteredBaselevelObjects
	
	^ clusteredBaselevelObjects! !

!FLAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 11/3/2010 14:58'!
clusteredMetalevelObjects
	
	^ clusteredMetalevelObjects ! !

!FLAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 11/3/2010 15:44'!
clusteredObjects
	"Returns a new collection with all the clustered objects, in Association instances."
	
	^ (OrderedCollection new: clusteredMetalevelObjects size + clusteredBaselevelObjects size) 
		addAll: clusteredMetalevelObjects associations;
		addAll: clusteredBaselevelObjects associations;
		yourself.! !

!FLAnalyzer methodsFor: 'protected' stamp: 'MartinDias 11/11/2010 16:11'!
clusters: aDictionary add: anObject

	self
		clusters: aDictionary
		add: anObject
		serializer: anObject fuelSerializer! !

!FLAnalyzer methodsFor: 'protected' stamp: 'MartinDias 11/11/2010 16:19'!
clusters: aDictionary add: anObject serializer: aSerializer

	self 
		clusters: aDictionary 
		add: anObject 
		serializer: aSerializer 
		collectionFactoryBlock: [ IdentitySet new ]
! !

!FLAnalyzer methodsFor: 'protected' stamp: 'MartinDias 11/11/2010 18:31'!
clusters: aDictionary add: anObject serializer: aSerializer collectionFactoryBlock: aBlockForNewCollection

	| clusterObjects |
	clusterObjects := aDictionary at: aSerializer ifAbsentPut: [ aBlockForNewCollection value ].
	(clusterObjects includes: anObject)
		ifTrue: [ ^ self ].
	clusterObjects add: anObject.
	objectCount := objectCount + 1.
	aSerializer referencesOf: anObject do: [ :aChild | self analyze: aChild ]! !

!FLAnalyzer methodsFor: 'initialize-release' stamp: 'MartinDias 11/3/2010 14:58'!
initialize

	clusteredBaselevelObjects := Dictionary new.
	clusteredMetalevelObjects := Dictionary new.
	objectCount := 0.
	analyzers := OrderedCollection new.
! !

!FLAnalyzer methodsFor: 'initialize-release' stamp: 'MartinDias 10/26/2010 10:30'!
initializeDefaultAnalyzers

	analyzers 
		add: (FLGlobalAssociationAnalyzer newWith: self);
		add: (FLClassPoolAssociationAnalyzer newWith: self);
		add: (FLGlobalAnalyzer newWith: self);
		add: (FLDefaultAnalyzer newWith: self)
! !

!FLAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 10/19/2010 10:31'!
objectCount

	^ objectCount! !

Object subclass: #FLClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

FLClusterSerializer class
	instanceVariableNames: 'instance serializersById'!

!FLClusterSerializer commentStamp: '<historical>' prior: 0!
I represent a special way of serialize and materialize some specific kind of objects.

Each of my non-abstract subclasses answers to #id with an unique integer, that identifies it. 

Sending me the #forId: message you obtain an instance that corresponds with an specific id. 

Every object responds to #fuelSerializer with its corresponding subclass of me. For example:

	42 fuelSerializer 
	
will return a serializer for SmallInteger.!

FLClusterSerializer class
	instanceVariableNames: 'instance serializersById'!

FLClusterSerializer subclass: #FLArrayedCollectionClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLArrayedCollectionClusterSerializer commentStamp: '<historical>' prior: 0!
I am a cluster serializer for ArrayedCollections. I am a template class, my concrete subclasses implement a hook method for specify which concrete ArrayedCollection serializes.

I use the ArrayedCollection messages #writeOn: and #newFromStream: for serialize and materialize instances.!

!FLArrayedCollectionClusterSerializer methodsFor: 'protected' stamp: 'MartinDias 12/2/2010 13:18'!
arrayedCollectionClass
	"Hook method for specify the concrete ArrayedCollection subclass"

	self subclassResponsibility! !

!FLArrayedCollectionClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/2/2010 13:17'!
materializeAllWith: aMaterializer
	
	aMaterializer nextInteger timesRepeat: [ 
		aMaterializer addMaterialized: (self arrayedCollectionClass newFromStream: aMaterializer stream) ]! !

!FLArrayedCollectionClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/2/2010 13:31'!
serializeAll: arrayedCollections with: aSerializer

	aSerializer nextPutInteger: arrayedCollections size.
	arrayedCollections do: [ :anArrayedCollection |
		anArrayedCollection writeOn: aSerializer stream ]! !

FLArrayedCollectionClusterSerializer subclass: #FLBitmapClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLBitmapClusterSerializer commentStamp: '<historical>' prior: 0!
I am a cluster serializer for Bitmap instances.!

!FLBitmapClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 12/2/2010 13:26'!
id

	^ 61! !

!FLBitmapClusterSerializer methodsFor: 'protected' stamp: 'MartinDias 12/2/2010 13:26'!
arrayedCollectionClass

	^ Bitmap! !

FLArrayedCollectionClusterSerializer subclass: #FLWordArrayForSegmentClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLWordArrayForSegmentClusterSerializer commentStamp: '<historical>' prior: 0!
I am a cluster serializer for WordArrayForSegment instances.!

!FLWordArrayForSegmentClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 12/2/2010 13:20'!
id

	^ 60! !

!FLWordArrayForSegmentClusterSerializer methodsFor: 'protected' stamp: 'MartinDias 12/2/2010 13:21'!
arrayedCollectionClass

	^ WordArrayForSegment! !

!FLClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 15:24'!
allSubclassesWithId
	"Answers a collection with all the subclasses that define an id. In other words, all the non-abstract subclasses are returned"

	^self allSubclasses select: [ :aClass | 
			[ aClass id isInteger ] ifError: [ false ] ] 
	! !

!FLClusterSerializer classSide methodsFor: 'instance creation' stamp: 'MartinDias 10/18/2010 12:34'!
forId: anInteger
	"Returns the serializer instance that corresponds to the id received"

	^ self serializersById 
			at: anInteger 
			ifAbsent: [ self error: 'Could not find a serializer with id=', anInteger asString ].
	
! !

!FLClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:56'!
id
	"Answer an integer identifier. It must be between 0 and 255. 
	Each type of primitive object should have a different one. 
	validateIdDistribution checks that there is no overlap."
	
	self subclassResponsibility ! !

!FLClusterSerializer classSide methodsFor: 'class initialization' stamp: 'MartinDias 10/15/2010 13:11'!
initialize
	"Initializes singleton class variables"

	super initialize.
	instance := nil.
	serializersById := nil.! !

!FLClusterSerializer classSide methodsFor: 'class initialization' stamp: 'MartinDias 10/19/2010 16:41'!
initializeHierarchy
	"Initializes class variables in the whole hierarchy"

	self withAllSubclasses do: [ :x | x initialize ].  ! !

!FLClusterSerializer classSide methodsFor: 'instance creation' stamp: 'MartinDias 10/15/2010 11:29'!
instance
	"Returns the singleton instance of this class. It may not be sent to abstract classes, see class doc."
	
	^ instance ifNil: [ instance := self basicNew initialize ]
	
! !

!FLClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 15:16'!
serializersById
	"Returns a dictionary that indexes the serializers by their ids"

	serializersById ifNil: [
			serializersById := IdentityDictionary new.
			self allSubclassesWithId 
				do: [ :aSerializerClass | 
					serializersById 
						at: aSerializerClass id 
						put: aSerializerClass instance ] ].
	^ serializersById 
! !

!FLClusterSerializer classSide methodsFor: 'checking' stamp: 'MartinDias 10/12/2010 16:06'!
validateIdDistribution
	"Verifies that subclasses do not have overlapping ids"
	
	self assert: (self allSubclassesWithId collect: [ :aClass | aClass id ]) hasAnyDuplicate not
		description: 'Overlapping id detected in FLClusterSerializer subclasses'! !

!FLClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 11:35'!
materializeAllWith: aMaterializer

	self subclassResponsibility ! !

!FLClusterSerializer methodsFor: 'analyzing' stamp: 'MartinDias 11/11/2010 18:31'!
referencesOf: anObject do: aBlock
! !

!FLClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 11:11'!
serializeAll: clusterInstances with: aSerializer

	self subclassResponsibility ! !

FLClusterSerializer subclass: #FLIteratingClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLIteratingClusterSerializer commentStamp: '<historical>' prior: 0!
I am a template class whose algorithm for serialize a collection of objects consists on delegate the serialization of each individual object to the subclass.!

FLIteratingClusterSerializer subclass: #FLClassPoolAssociationClusterSerializer
	instanceVariableNames: 'ownerClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLClassPoolAssociationClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for variable bindings that belong to the class pool of a Class included on Smalltalk globals.!

!FLClassPoolAssociationClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/18/2010 18:02'!
id

	^ 20! !

!FLClassPoolAssociationClusterSerializer classSide methodsFor: 'instance creation' stamp: 'MartinDias 10/18/2010 17:55'!
newFor: aClass

	^ self basicNew
		initialize;
		ownerClass: aClass;
		yourself.! !

!FLClassPoolAssociationClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/18/2010 18:07'!
materializeWith: aMaterializer

	| keyName |
	ownerClass := aMaterializer nextReferencedObject.
	keyName := aMaterializer stream nextString.
	^ ownerClass classPool associationAt: keyName asSymbol ! !

!FLClassPoolAssociationClusterSerializer methodsFor: 'accessing' stamp: 'MartinDias 10/18/2010 17:59'!
ownerClass: anObject
	ownerClass := anObject! !

!FLClassPoolAssociationClusterSerializer methodsFor: 'analyzing' stamp: 'MartinDias 11/11/2010 18:31'!
referencesOf: anAssociation do: aBlock

	aBlock value: ownerClass! !

!FLClassPoolAssociationClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/18/2010 18:07'!
serialize: anAssociation with: aSerializer

	aSerializer nextPutReferenceTo: ownerClass.
	aSerializer stream nextStringPut: anAssociation key asString! !

FLIteratingClusterSerializer subclass: #FLCompiledMethodClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLCompiledMethodClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for CompiledMethod instances.!

!FLCompiledMethodClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:19'!
id
	^2! !

!FLCompiledMethodClusterSerializer methodsFor: 'protected' stamp: 'MartinDias 10/7/2010 00:36'!
materializeLiteralsTo: compiledMethod with: aMaterializer

	1 to: compiledMethod numLiterals 
		do: [ :index | compiledMethod literalAt: index put: aMaterializer nextReferencedObject ]
! !

!FLCompiledMethodClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 11/26/2010 17:42'!
materializeWith: aMaterializer

	| compiledMethod header source trailer bytecodesSize aReadStream |

	aReadStream := aMaterializer stream.

	header := (aReadStream nextWord << 16) bitOr: aReadStream nextWord.
	bytecodesSize := aReadStream nextWord.
	"source := aReadStream nextString."
	source := (aReadStream nextWord << 16) bitOr: aReadStream nextWord.

	trailer := CompiledMethodTrailer new 
		"sourceCode: source;" 
		sourcePointer: source;
		yourself.

	compiledMethod := trailer createMethod: bytecodesSize header: header.

	compiledMethod initialPC - 1 to: compiledMethod endPC
		do: [ :index | compiledMethod at: index put: aReadStream next ].

	aMaterializer referenceMaterializingActionsAdd: 
		[ self materializeLiteralsTo: compiledMethod with: aMaterializer ].
		
	^ compiledMethod! !

!FLCompiledMethodClusterSerializer methodsFor: 'analyzing' stamp: 'MartinDias 11/11/2010 18:31'!
referencesOf: anObject do: aBlock

	1 to: anObject numLiterals
		do: [ :index | aBlock value: (anObject literalAt: index) ]! !

!FLCompiledMethodClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 11/26/2010 17:42'!
serialize: aCompiledMethod with: aSerializer

	| header source aWriteStream bytecodesSize |

	aWriteStream := aSerializer stream.

	header := aCompiledMethod header.
	bytecodesSize := aCompiledMethod endPC - aCompiledMethod initialPC + 1.
	"source := aCompiledMethod getSource."
	source := aCompiledMethod sourcePointer.

	aWriteStream 
		nextWordPut: (header >> 16);
		nextWordPut: header;
		nextWordPut: bytecodesSize;
		"nextStringPut: source asString."
		nextWordPut: (source >> 16);
		nextWordPut: source.

	aCompiledMethod initialPC - 1 to: aCompiledMethod endPC
		do: [ :index | aWriteStream nextPut: (aCompiledMethod at: index) ].

	aSerializer referenceSerializingActionsAdd: 
		[ self serializeLiteralsOf: aCompiledMethod with: aSerializer ]! !

!FLCompiledMethodClusterSerializer methodsFor: 'protected' stamp: 'MartinDias 10/7/2010 00:36'!
serializeLiteralsOf: aCompiledMethod with: aSerializer

	1 to: aCompiledMethod numLiterals 
		do: [ :index | aSerializer nextPutReferenceTo: (aCompiledMethod literalAt: index) ]! !

FLCompiledMethodClusterSerializer subclass: #FLNamedPrimitiveMethodClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLNamedPrimitiveMethodClusterSerializer commentStamp: 'MartinDias 11/2/2010 15:33' prior: 0!
I am a serializer for CompiledMethods which are <primitive:module:> primitives.

For example, Integer >> bitAnd: should be serialized with me.!

!FLNamedPrimitiveMethodClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/22/2010 12:08'!
id

	^ 23! !

!FLNamedPrimitiveMethodClusterSerializer methodsFor: 'protected' stamp: 'MartinDias 11/11/2010 18:33'!
materializeLiteralsTo: compiledMethod with: aMaterializer

	| module name |
	module := aMaterializer nextReferencedObject.
	name := aMaterializer nextReferencedObject.
	compiledMethod literalAt: 1 put: (Array with: module with: name with: 0 with: 0).

	2 to: compiledMethod numLiterals 
		do: [ :index | compiledMethod literalAt: index put: aMaterializer nextReferencedObject ]
! !

!FLNamedPrimitiveMethodClusterSerializer methodsFor: 'analyzing' stamp: 'MartinDias 11/11/2010 18:31'!
referencesOf: anObject do: aBlock

	aBlock 
		value: (anObject literalAt: 1) first;
		value: (anObject literalAt: 1) second. 

	2 to: anObject numLiterals
		do: [ :index | aBlock value: (anObject literalAt: index) ]! !

!FLNamedPrimitiveMethodClusterSerializer methodsFor: 'protected' stamp: 'MartinDias 10/26/2010 14:43'!
serializeLiteralsOf: aCompiledMethod with: aSerializer

	| primitiveArguments |
	
	primitiveArguments := aCompiledMethod literalAt: 1.
	aSerializer 
		nextPutReferenceTo: primitiveArguments first;
		nextPutReferenceTo: primitiveArguments second.

	2 to: aCompiledMethod numLiterals 
		do: [ :index | aSerializer nextPutReferenceTo: (aCompiledMethod literalAt: index) ]! !

!FLIteratingClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 13:27'!
materializeAllWith: aMaterializer
	"Template method that let to the subclass the materialization using the received materializer"

	| instanceCount |
	instanceCount := aMaterializer nextInteger.

	instanceCount timesRepeat: 
		[ aMaterializer addMaterialized: 
			(self materializeWith: aMaterializer) ].! !

!FLIteratingClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 13:30'!
materializeWith: aMaterializer
	"Hook method that each subclass should customize for its special way of materializing"

	^ self subclassResponsibility! !

!FLIteratingClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 11/11/2010 18:02'!
serialize: anObject with: aSerializer
	"Hook method that each subclass should customize for its special way of serializing"

	self subclassResponsibility ! !

!FLIteratingClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 13:27'!
serializeAll: aCollection with: aSerializer
	"Template method that let to the subclass the serialization of each instance received"

	aSerializer nextPutInteger: aCollection size.
	aCollection do: [ :instance | self serialize: instance with: aSerializer ]! !

FLIteratingClusterSerializer subclass: #FLMetaclassClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLMetaclassClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for Metaclasses.!

!FLMetaclassClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:24'!
id
	^ 12! !

!FLMetaclassClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/5/2010 14:28'!
materializeWith: aMaterializer

	^ aMaterializer nextReferencedObject class.! !

!FLMetaclassClusterSerializer methodsFor: 'analyzing' stamp: 'MartinDias 11/11/2010 18:31'!
referencesOf: aMetaclass do: aBlock

	aBlock value: aMetaclass soleInstance! !

!FLMetaclassClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/5/2010 14:28'!
serialize: aMetaclass with: aSerializer

	aSerializer nextPutReferenceTo: aMetaclass soleInstance.
! !

FLClusterSerializer subclass: #FLObjectClusterSerializer
	instanceVariableNames: 'clusteredClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLObjectClusterSerializer commentStamp: '<historical>' prior: 0!
I implement a generic way of serializing and materializing an object, for those that do not need more special way of doing it.

For example,

	10@20 fuelSerializer 

returns an instance of me.

!

!FLObjectClusterSerializer classSide methodsFor: 'instance creation' stamp: 'MartinDias 10/12/2010 12:54'!
for: aClass

	^ self basicNew
		clusteredClass: aClass;
		yourself.! !

!FLObjectClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:24'!
id

	^0! !

!FLObjectClusterSerializer methodsFor: 'comparing' stamp: 'MartinDias 10/15/2010 11:00'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ self clusteredClass = anObject clusteredClass! !

!FLObjectClusterSerializer methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 12:54'!
clusteredClass
	^ clusteredClass ! !

!FLObjectClusterSerializer methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 12:54'!
clusteredClass: aClass

	clusteredClass := aClass! !

!FLObjectClusterSerializer methodsFor: 'comparing' stamp: 'MartinDias 10/15/2010 11:00'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ self clusteredClass hash! !

!FLObjectClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 2/26/2011 03:07'!
materializeAllWith: aMaterializer

	| instanceCount clusterInstances class instanceVariablesMapping numberOfInstanceVariables instanceVariableNames |

	self flag: #todo. "refactor this big method"

	class := aMaterializer nextReferencedObject.
	numberOfInstanceVariables := aMaterializer stream next.
	instanceVariableNames := (1 to: numberOfInstanceVariables) collect: [ :index | aMaterializer stream nextString ].
	instanceCount := aMaterializer nextInteger.
	clusterInstances := OrderedCollection new: instanceCount.

	instanceVariablesMapping := FLInstanceVariablesMapping 
			currentClass: class 
			originalInstanceVariableNames: instanceVariableNames.

	class isVariable
		ifTrue: [ 
			instanceCount timesRepeat: [ clusterInstances add: (class basicNew: aMaterializer nextInteger) ].
			aMaterializer referenceMaterializingActionsAdd: [ 
				self materializeVariableReferencesOfAll: clusterInstances with: aMaterializer ] ]
		ifFalse: [ 
			instanceCount timesRepeat: [ clusterInstances add: class basicNew ] ].

	class hasInstanceVariables
		ifTrue: [ 
			aMaterializer referenceMaterializingActionsAdd: [ 
				self 
					materializeReferencesOfAll: clusterInstances 
					with: aMaterializer 
					instanceVariablesMapping: instanceVariablesMapping ] ].
		
	aMaterializer addAllMaterialized: clusterInstances! !

!FLObjectClusterSerializer methodsFor: 'protected' stamp: 'MartinDias 11/12/2010 01:03'!
materializeReferencesOfAll: instances with: aMaterializer instanceVariablesMapping: instanceVariablesMapping
	
	instances
		do: [ :instance |
			instanceVariablesMapping materializeReferencesOf: instance with: aMaterializer ]! !

!FLObjectClusterSerializer methodsFor: 'protected' stamp: 'MartinDias 11/11/2010 18:14'!
materializeVariableReferencesOfAll: instances with: aMaterializer

	instances
		do: [ :instance |
			1 to: instance basicSize 
				do: [ :index | instance basicAt: index put: aMaterializer nextReferencedObject ]]! !

!FLObjectClusterSerializer methodsFor: 'analyzing' stamp: 'MartinDias 11/11/2010 18:31'!
referencesOf: anObject do: aBlock

	aBlock value: anObject class.

	anObject class isVariable 
		ifTrue: [ 
			1 to: anObject basicSize 
				do: [ :index | aBlock value: (anObject basicAt: index) ] ].
	
	1 to: anObject class instSize 
		do: [ :index | aBlock value: (anObject instVarAt: index) ]! !

!FLObjectClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 11/11/2010 20:33'!
serializeAll: clusterInstances with: aSerializer

	self serializeClassInfoWith: aSerializer.
	aSerializer nextPutInteger: clusterInstances size.

	clusteredClass isVariable
		ifTrue: [ 
			clusterInstances do: [ :instance | aSerializer nextPutInteger: instance basicSize ].
			aSerializer referenceSerializingActionsAdd:
				[ self serializeVariableReferencesOfAll: clusterInstances with: aSerializer ] ].

	clusteredClass hasInstanceVariables
		ifTrue: [ 
			aSerializer referenceSerializingActionsAdd:
				[ self serializeReferencesOfAll: clusterInstances with: aSerializer ] ]! !

!FLObjectClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 11/11/2010 21:17'!
serializeClassInfoWith: aSerializer

	aSerializer nextPutReferenceTo: clusteredClass.
	aSerializer stream nextPut: clusteredClass instSize. 
	clusteredClass instVarNamesAndOffsetsDo: [ :name :index | aSerializer stream nextStringPut: name ].
	
	self flag: #todo. "only 256 instance variables?"
! !

!FLObjectClusterSerializer methodsFor: 'protected' stamp: 'MartinDias 10/13/2010 11:13'!
serializeReferencesOfAll: instances with: aSerializer 
	
	instances 
		do: [ :anInstance |
			1 to: clusteredClass instSize do: [ :index |
				aSerializer nextPutReferenceTo: (anInstance instVarAt: index) ]]
				
	! !

!FLObjectClusterSerializer methodsFor: 'protected' stamp: 'MartinDias 10/13/2010 11:14'!
serializeVariableReferencesOfAll: instances with: aSerializer

	instances 
		do: [ :anInstance |
			1 to: anInstance basicSize do: [ :index |
				aSerializer nextPutReferenceTo: (anInstance basicAt: index) ]]! !

FLClusterSerializer subclass: #FLPrimitiveClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLPrimitiveClusterSerializer commentStamp: '<historical>' prior: 0!
I am a template class whose algorithm for serialize a collection of objects is to delegate the serialization of each individual object to the subclass. 

(TODO) My main difference with FLIteratingClusterSerializer is that my method hooks only receive a stream and not the complete instance of FLSerializer, because they have not need. But possibly there is no reason for being different classes.!

FLPrimitiveClusterSerializer subclass: #FLByteArrayClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLByteArrayClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for ByteArray.!

!FLByteArrayClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/25/2010 14:37'!
id

	^25! !

!FLByteArrayClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/25/2010 14:37'!
materializeFrom: aReadStream

	^ aReadStream nextString asByteArray! !

!FLByteArrayClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/25/2010 14:37'!
serialize: aByteArray on: aWriteStream

	aWriteStream nextStringPut: aByteArray asString ! !

FLPrimitiveClusterSerializer subclass: #FLByteStringClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLByteStringClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for ByteString.!

!FLByteStringClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/25/2010 13:32'!
id

	^24! !

!FLByteStringClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/25/2010 13:38'!
materializeFrom: aReadStream

	^ aReadStream nextString! !

!FLByteStringClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/25/2010 13:38'!
serialize: aString on: aWriteStream

	aWriteStream nextStringPut: aString! !

FLPrimitiveClusterSerializer subclass: #FLCharacterClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLCharacterClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for Character.!

!FLCharacterClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:24'!
id

	^1! !

!FLCharacterClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 11:06'!
materializeFrom: aReadStream

	^Character value: aReadStream next! !

!FLCharacterClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 11/22/2010 17:33'!
serialize: aCharacter on: aWriteStream

	aWriteStream nextPut: aCharacter codePoint! !

FLPrimitiveClusterSerializer subclass: #FLFloatClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLFloatClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for 8-byte Floats. 

Implementation took from ReferenceStream.
!

!FLFloatClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/20/2010 22:45'!
id
	^21! !

!FLFloatClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/21/2010 13:27'!
materializeFrom: aReadStream

	^ (Float new: 2)
		at: 1 put: (aReadStream nextNumber: 4);
		at: 2 put: (aReadStream nextNumber: 4);
		yourself.
! !

!FLFloatClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/21/2010 10:39'!
serialize: aFloat on: aWriteStream

	aWriteStream 
		nextNumber: 4 put: (aFloat at: 1);
		nextNumber: 4 put: (aFloat at: 2).! !

FLPrimitiveClusterSerializer subclass: #FLGlobalAssociationClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLGlobalAssociationClusterSerializer commentStamp: '<historical>' prior: 0!
I serialize variable bindings that belong to Smalltalk global dictionary.

For example, 

	Smalltalk globals associationAt: #Transcript 
	
could be serialized by me.!

!FLGlobalAssociationClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/18/2010 12:16'!
id
	^ 19! !

!FLGlobalAssociationClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/19/2010 15:08'!
materializeFrom: aReadStream

	^ Smalltalk globals 
		associationAt: aReadStream nextString asSymbol
		ifAbsent: [ self error: 'Association not found.' ] ! !

!FLGlobalAssociationClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/18/2010 12:10'!
serialize: anAssociation on: aWriteStream
	
	aWriteStream nextStringPut: anAssociation key! !

FLPrimitiveClusterSerializer subclass: #FLGlobalClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLGlobalClusterSerializer commentStamp: 'MartinDias 11/15/2010 11:16' prior: 0!
I am a serializer for known objects that belong to Smalltalk global dictionary.

For example, Transcript could be serialized by me.!

!FLGlobalClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:25'!
id
	^ 11! !

!FLGlobalClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/19/2010 14:52'!
materializeFrom: aReadStream

	^ Smalltalk globals 
		at: aReadStream nextString asSymbol 
		ifAbsent: [ self error: 'Smalltalk global not found' ]! !

!FLGlobalClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/19/2010 14:52'!
serialize: anObject on: aWriteStream
	
	aWriteStream 
		nextStringPut: (Smalltalk globals keyAtValue: anObject) asString.! !

FLPrimitiveClusterSerializer subclass: #FLLargeNegativeIntegerClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLLargeNegativeIntegerClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for LargeNegativeInteger.!

!FLLargeNegativeIntegerClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:25'!
id
	^8! !

!FLLargeNegativeIntegerClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/12/2010 21:39'!
materializeFrom: aReadStream

	| size value |
	size := aReadStream next.
	value := 0.
	size timesRepeat: [value := (value bitShift: 8) bitOr: aReadStream next].
	^ value negated ! !

!FLLargeNegativeIntegerClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/12/2010 10:44'!
serialize: anInteger on: aWriteStream

	| size byte positive |
	positive := anInteger abs.
	size := (positive log: 256) floor + 1.
	aWriteStream nextPut:size.
	(size - 1 to: 0 by: -1) do:
		[:index |
			byte := (positive bitShift: index * -8) bitAnd: 255.
			aWriteStream nextPut: byte]! !

FLPrimitiveClusterSerializer subclass: #FLLargePositiveIntegerClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLLargePositiveIntegerClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for LargePositiveInteger.!

!FLLargePositiveIntegerClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:25'!
id
	^7! !

!FLLargePositiveIntegerClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/12/2010 21:39'!
materializeFrom: aReadStream

	| size value |
	size:=aReadStream next.
	value := 0.
	size timesRepeat: [value := (value bitShift: 8) bitOr: aReadStream next].
	^ value! !

!FLLargePositiveIntegerClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 9/27/2010 13:42'!
serialize: anInteger on: aWriteStream

	| size byte |
	size:=(anInteger log: 256) floor + 1.
	aWriteStream nextPut: size.
	(size - 1 to: 0 by: -1) do:
		[:index |
		byte := (anInteger bitShift: index * -8) bitAnd: 255.
		aWriteStream nextPut: byte]! !

FLPrimitiveClusterSerializer subclass: #FLNilTrueFalseClusterSerializer
	instanceVariableNames: ''
	classVariableNames: 'WellKnownObjectsDictionary'
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLNilTrueFalseClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for nil, true and false. They have a special treatment because they are so common in the image.!

!FLNilTrueFalseClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/19/2010 12:20'!
id

	^4! !

!FLNilTrueFalseClusterSerializer classSide methodsFor: 'class initialization' stamp: 'MartinDias 10/19/2010 12:22'!
initialize 

	super initialize.
	WellKnownObjectsDictionary := Dictionary new
		add: 1 -> nil;
		add: 2 -> true;
		add: 3 -> false;
		yourself.! !

!FLNilTrueFalseClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/19/2010 12:21'!
materializeFrom: aReadStream
	
	^ WellKnownObjectsDictionary at: aReadStream next
	! !

!FLNilTrueFalseClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/19/2010 13:30'!
serialize: aWellKnownObject on: aWriteStream

	aWriteStream nextPut: (WellKnownObjectsDictionary keyAtValue: aWellKnownObject)! !

!FLPrimitiveClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 13:28'!
materializeAllWith: aMaterializer 
	"Template method that let to the subclass the materialization using the received materializer"
	
	| instanceCount |
	instanceCount := aMaterializer nextInteger.

	instanceCount timesRepeat: 
		[ aMaterializer addMaterialized: 
			(self materializeFrom: aMaterializer stream) ].! !

!FLPrimitiveClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 13:30'!
materializeFrom: aReadStream
	"Hook method that each subclass should customize for its special way of materializing"
	
	self subclassResponsibility ! !

!FLPrimitiveClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 13:29'!
serialize: anObject on: aWriteStream
	"Hook method that each subclass should customize for its special way of serializing"
	
	self subclassResponsibility! !

!FLPrimitiveClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 13:28'!
serializeAll: aCollection with: aSerializer
	"Template method that let to the subclass the serialization of each instance received"
	
	aSerializer nextPutInteger: aCollection size.
	aCollection do: [ :instance | self serialize: instance on: aSerializer stream ]! !

FLPrimitiveClusterSerializer subclass: #FLReferencedClassClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLReferencedClassClusterSerializer commentStamp: 'MartinDias 11/15/2010 11:20' prior: 0!
I am a serializer for classes that should be present when materializing. In other words, it only serializes a reference to the class, using its name.!

!FLReferencedClassClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 11/11/2010 21:01'!
id
	^ 81! !

!FLReferencedClassClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 11/11/2010 21:01'!
materializeFrom: aReadStream

	^ Smalltalk globals 
		at: aReadStream nextString asSymbol 
		ifAbsent: [ self error: 'Class not found' ]! !

!FLReferencedClassClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 11/11/2010 21:00'!
serialize: aClass on: aWriteStream
	
	aWriteStream nextStringPut: aClass name asString! !

FLPrimitiveClusterSerializer subclass: #FLSmallIntegerClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLSmallIntegerClusterSerializer commentStamp: '<historical>' prior: 0!
I don't have so much sense as a class, but I know which of my subclasses corresponds to each SmallInteger.!

FLSmallIntegerClusterSerializer subclass: #FLNegativeSmallIntegerClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLNegativeSmallIntegerClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for negative SmallInteger instances.!

!FLNegativeSmallIntegerClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:26'!
id
	^10! !

!FLNegativeSmallIntegerClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/12/2010 21:39'!
materializeFrom: aReadStream

	| hi mid1 mid2 lo |
	hi := aReadStream next.
	mid2 := aReadStream next.
	mid1 := aReadStream next.
	lo := aReadStream next.
	^ ((hi bitShift: 24) + (mid2 bitShift: 16) + (mid1 bitShift: 8) + lo) negated! !

!FLNegativeSmallIntegerClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/12/2010 10:38'!
serialize: anInteger on: aWriteStream

	| aPositiveInteger |
	aPositiveInteger := anInteger abs.
	aWriteStream nextPut: (aPositiveInteger bitShift: -24).
	aWriteStream nextPut: ((aPositiveInteger bitShift: -16) bitAnd: 255).
	aWriteStream nextPut: ((aPositiveInteger bitShift: -8) bitAnd: 255).
	aWriteStream nextPut: (aPositiveInteger bitAnd: 255).! !

FLSmallIntegerClusterSerializer subclass: #FLPositiveSmallIntegerClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLPositiveSmallIntegerClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for positive SmallInteger instances.!

!FLPositiveSmallIntegerClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:26'!
id
	^9! !

!FLPositiveSmallIntegerClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/15/2010 10:51'!
materializeFrom: aReadStream

	| hi mid1 mid2 lo |
	hi := aReadStream next.
	mid2 := aReadStream next.
	mid1 := aReadStream next.
	lo := aReadStream next.
	^ (((hi bitShift: 24) bitXor: (mid2 bitShift: 16)) bitXor: (mid1 bitShift: 8)) bitXor: lo! !

!FLPositiveSmallIntegerClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 9/24/2010 00:48'!
serialize: anInteger on: aWriteStream

	aWriteStream nextPut: (anInteger bitShift: -24).
	aWriteStream nextPut: ((anInteger bitShift: -16) bitAnd: 255).
	aWriteStream nextPut: ((anInteger bitShift: -8) bitAnd: 255).
	aWriteStream nextPut: (anInteger bitAnd: 255).! !

!FLSmallIntegerClusterSerializer classSide methodsFor: 'instance creation' stamp: 'MartinDias 12/28/2010 14:27'!
for: anSmallInteger
	"Returns the right subclass instance"

	((anSmallInteger bitAnd: 16rFFFF) = anSmallInteger)
		ifTrue: [ ^ FLUInt16ClusterSerializer instance ].

	anSmallInteger > 0 
		ifTrue: [ ^ FLPositiveSmallIntegerClusterSerializer instance ]
		ifFalse: [ ^ FLNegativeSmallIntegerClusterSerializer instance ]! !

FLSmallIntegerClusterSerializer subclass: #FLUInt16ClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLUInt16ClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for SmallInteger instances between 0 and 16rFFFF.!

!FLUInt16ClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 12/22/2010 12:21'!
id
	^90! !

!FLUInt16ClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/22/2010 12:20'!
materializeFrom: aReadStream

	| hi lo |
	hi := aReadStream next.
	lo := aReadStream next.
	^ (hi bitShift: 8) bitXor: lo! !

!FLUInt16ClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/22/2010 13:16'!
serialize: anInteger on: aWriteStream

	aWriteStream nextPut: (anInteger bitShift: -8).
	aWriteStream nextPut: (anInteger bitAnd: 255).! !

FLPrimitiveClusterSerializer subclass: #FLSymbolClusterSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLSymbolClusterSerializer commentStamp: '<historical>' prior: 0!
I am a serializer for Symbol instances.!

!FLSymbolClusterSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:26'!
id

	^3! !

!FLSymbolClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/26/2010 14:22'!
materializeFrom: aReadStream

	^ aReadStream nextString asSymbol! !

!FLSymbolClusterSerializer methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/26/2010 14:22'!
serialize: aSymbol on: aWriteStream

	aWriteStream nextStringPut: aSymbol asString! !

Object subclass: #FLContainerReader
	instanceVariableNames: 'materializers signature'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Container'!

!FLContainerReader methodsFor: 'initialize-release' stamp: 'MartinDias 2/25/2011 20:54'!
initialize

	materializers := Dictionary new.
	! !

!FLContainerReader methodsFor: 'accessing' stamp: 'MartinDias 2/25/2011 20:58'!
materializers
	^ materializers! !

!FLContainerReader methodsFor: 'reading' stamp: 'MartinDias 2/26/2011 04:47'!
nextOn: aStream
	| readSignature version materializer |
	readSignature := aStream next: self signature size.
	(self signature = readSignature) ifFalse: [ self error: 'Bad format.' ].
	
	version := aStream nextWord.
	materializer := materializers at: version ifAbsent: [ self error: 'Bad version: ', version, '.' ].
	
	^ materializer value: aStream! !

!FLContainerReader methodsFor: 'accessing' stamp: 'MartinDias 2/25/2011 23:36'!
signature
	^ signature! !

!FLContainerReader methodsFor: 'accessing' stamp: 'MartinDias 2/25/2011 23:37'!
signature: aSmallInteger
	signature := aSmallInteger! !

Object subclass: #FLContainerWriter
	instanceVariableNames: 'serializers currentVersion signature'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Container'!

!FLContainerWriter methodsFor: 'accessing' stamp: 'MartinDias 2/25/2011 23:06'!
currentSerializer

	^ serializers at: self currentVersion! !

!FLContainerWriter methodsFor: 'accessing' stamp: 'MartinDias 2/25/2011 23:14'!
currentVersion
	^ currentVersion! !

!FLContainerWriter methodsFor: 'accessing' stamp: 'MartinDias 2/25/2011 23:18'!
currentVersion: aCurrentVersion
	currentVersion := aCurrentVersion! !

!FLContainerWriter methodsFor: 'initialize-release' stamp: 'MartinDias 2/25/2011 23:06'!
initialize

	serializers := Dictionary new.! !

!FLContainerWriter methodsFor: 'writing' stamp: 'MartinDias 2/26/2011 05:46'!
on: aStream nextPut: anObject 

	aStream 
		nextPutAll: self signature;
		nextWordPut: self currentVersion.
	
	self currentSerializer value: aStream value: anObject! !

!FLContainerWriter methodsFor: 'accessing' stamp: 'MartinDias 2/25/2011 23:08'!
serializers
	^ serializers! !

!FLContainerWriter methodsFor: 'accessing' stamp: 'MartinDias 2/25/2011 23:36'!
signature
	^ signature! !

!FLContainerWriter methodsFor: 'accessing' stamp: 'MartinDias 2/25/2011 23:24'!
signature: aSmallInteger 
	signature := aSmallInteger! !

Object subclass: #FLInstanceVariablesMapping
	instanceVariableNames: 'mapping'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Cluster'!

!FLInstanceVariablesMapping commentStamp: 'MartinDias 11/15/2010 11:40' prior: 0!
I am used to materialize instance variables in an object, tolerating "class shape changing".

Cases tolerated are:
- instance variable added
- instance variable order change
- instance variable removed

Note: This class may be refactorized, because it looks a bit weird.!

!FLInstanceVariablesMapping classSide methodsFor: 'instance creation' stamp: 'MartinDias 11/12/2010 00:58'!
currentClass: aClass originalInstanceVariableNames: originalInstanceVariableNames 
	
	^ self basicNew
		initializeWith: originalInstanceVariableNames and: aClass;
		yourself.! !

!FLInstanceVariablesMapping methodsFor: 'initialize-release' stamp: 'MartinDias 11/12/2010 00:58'!
initializeWith: originalInstanceVariableNames and: currentClass

	super initialize.
	
	mapping := originalInstanceVariableNames 
		collect: [ :name | currentClass instVarIndexFor: name ifAbsent: [ nil ] ].

! !

!FLInstanceVariablesMapping methodsFor: 'materialize' stamp: 'MartinDias 11/12/2010 01:17'!
materializeReferencesOf: anObject with: aMaterializer 

	1 to: mapping size 
		do: [ :index | 
			| referencedObject mappedIndex |
			
			referencedObject := aMaterializer nextReferencedObject.
			mappedIndex := mapping at: index.
			
			mappedIndex ifNotNil: [ 
					anObject 
						instVarAt: mappedIndex 
						put: referencedObject ] ].! !

Object subclass: #FLMaterializer
	instanceVariableNames: 'stream referenceMaterializingActions materializedInstances integerMaterializer materializedRoot clusterCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core'!

!FLMaterializer commentStamp: '<historical>' prior: 0!
I am a binary object materializer. 

By sending me #materialize, I will recreate previously serialized objects by FLSerializer from a byte stream. The results are obtained sending #materializedRoots.

!

!FLMaterializer class methodsFor: 'creation' stamp: 'MartinDias 9/20/2010 20:34'!
on: aReadStream

	^self new
		stream: aReadStream; 
		yourself
! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MartinDias 10/13/2010 11:31'!
addAllMaterialized: aCollection
	
	materializedInstances addAll: aCollection ! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MartinDias 10/13/2010 11:24'!
addMaterialized: anObject
	
	materializedInstances add: anObject ! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 10/12/2010 16:12'!
clusterSerializerFor: id

	^ FLClusterSerializer forId: id.! !

!FLMaterializer methodsFor: 'initialize-release' stamp: 'MartinDias 10/12/2010 16:29'!
initialize 
	
	super initialize.
	referenceMaterializingActions := OrderedCollection new.! !

!FLMaterializer methodsFor: 'materializing' stamp: 'MartinDias 11/25/2010 19:14'!
materialize

	self materializeHeader.
	self materializeInstances.
	self materializeReferences.
	self materializeRoot.! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 11/25/2010 12:39'!
materializeCluster

	(self clusterSerializerFor: self nextSerializerId)
		materializeAllWith: self! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 2/26/2011 04:22'!
materializeHeader

	integerMaterializer := self clusterSerializerFor: self nextSerializerId.
	materializedInstances := OrderedCollection new: self nextInteger.
	clusterCount := self nextInteger.
! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 11/25/2010 19:16'!
materializeInstances

	clusterCount timesRepeat: [self materializeCluster].
! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 9/11/2010 19:08'!
materializeReferences

	referenceMaterializingActions
		do: [ :aBlock | aBlock value ]
! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 10/28/2010 10:39'!
materializeRoot

	materializedRoot := self nextReferencedObject! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 10/12/2010 21:39'!
nextInteger
	^ integerMaterializer materializeFrom: stream! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 10/12/2010 21:39'!
nextReferencedObject 

	| referenceIndex |
	referenceIndex := integerMaterializer materializeFrom: stream.
	^ materializedInstances at: referenceIndex.! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 11/25/2010 12:38'!
nextSerializerId

	^ stream next! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MartinDias 10/15/2010 10:47'!
referenceMaterializingActionsAdd: aBlock
	"Adds an action for being valued at the references materializing step"
	
	referenceMaterializingActions add: aBlock ! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MartinDias 10/28/2010 10:51'!
root

	^ materializedRoot ! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MartinDias 10/6/2010 19:50'!
stream
	^ stream! !

!FLMaterializer methodsFor: 'accessing' stamp: 'sd 9/8/2010 15:23'!
stream: aStream
	stream:= aStream.! !

FLMaterializer subclass: #FLTestMaterializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Tests'!

FLTestMaterializer class
	instanceVariableNames: 'version'!

FLTestMaterializer class
	instanceVariableNames: 'version'!

!FLTestMaterializer classSide methodsFor: 'accessing' stamp: 'MartinDias 11/25/2010 19:24'!
version
	^ version! !

!FLTestMaterializer classSide methodsFor: 'accessing' stamp: 'MartinDias 11/25/2010 19:24'!
version: anObject
	version := anObject! !

Object subclass: #FLObjectAnalyzer
	instanceVariableNames: 'analyzer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Analyzer'!

!FLObjectAnalyzer commentStamp: '<historical>' prior: 0!
The purpose of my hierarchy is to collaborate with an Analyzer to traverse a graph of objects assigning to each of them an adequate FLClusterSerializer.!

FLObjectAnalyzer subclass: #FLClassPoolAssociationAnalyzer
	instanceVariableNames: ''
	classVariableNames: 'ClassPoolBindings'
	poolDictionaries: ''
	category: 'Fuel-Core-Analyzer'!

!FLClassPoolAssociationAnalyzer commentStamp: '<historical>' prior: 0!
I analyze variable bindings that belong to the class pool of a Class existent on Smalltalk globals.!

!FLClassPoolAssociationAnalyzer classSide methodsFor: 'class initialization' stamp: 'MarianoMartinezPeck 12/2/2010 15:31'!
classAdded: anEvent
	anEvent item classPool associationsDo: [ :aBinding | 
			ClassPoolBindings at: aBinding put: anEvent item ]


! !

!FLClassPoolAssociationAnalyzer classSide methodsFor: 'class initialization' stamp: 'MarianoMartinezPeck 12/2/2010 15:30'!
classRemoved: anEvent

	ClassPoolBindings
		removeKey: anEvent item
		ifAbsent: [ ]! !

!FLClassPoolAssociationAnalyzer classSide methodsFor: 'class initialization' stamp: 'MarianoMartinezPeck 12/2/2010 15:21'!
initialize

	super initialize.
	self initializeClassPoolBindings.
	self initializeListeners.
! !

!FLClassPoolAssociationAnalyzer classSide methodsFor: 'class initialization' stamp: 'MartinDias 2/26/2011 03:07'!
initializeClassPoolBindings
	ClassPoolBindings := Dictionary new.
	Smalltalk allClassesAndTraitsDo: [ :aClass | 
		aClass classPool associationsDo: [ :aBinding | 
			ClassPoolBindings at: aBinding put: aClass ] ].
	ClassPoolBindings! !

!FLClassPoolAssociationAnalyzer classSide methodsFor: 'class initialization' stamp: 'MarianoMartinezPeck 12/2/2010 15:21'!
initializeListeners

	self flag: #todo. "unregistrer? anocher better way of doing this?"

	SystemChangeNotifier uniqueInstance 
		notify: self
			ofSystemChangesOfItem: #class
			change: #Removed
			using: #classRemoved:;
		notify: self
			ofSystemChangesOfItem: #class
			change: #Added
			using: #classAdded:! !

!FLClassPoolAssociationAnalyzer methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/2/2010 15:21'!
analyzes: anObject
	 ^ anObject isVariableBinding and: [ ClassPoolBindings includesKey: anObject ]! !

!FLClassPoolAssociationAnalyzer methodsFor: 'evaluating' stamp: 'MarianoMartinezPeck 12/2/2010 15:43'!
value: anObject

	| ownerClass |
	ownerClass  := ClassPoolBindings at: anObject.
	
	analyzer 
		clusters: analyzer clusteredBaselevelObjects
		add: anObject  
		serializer: (FLClassPoolAssociationClusterSerializer newFor: ownerClass)! !

FLObjectAnalyzer subclass: #FLDefaultAnalyzer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Analyzer'!

!FLDefaultAnalyzer commentStamp: '<historical>' prior: 0!
I analyze objects using the serializer specified by each's #fuelSerializer message. 

I use the visitor pattern because I'm quite coupled to each serializer implementation. (TODO) Maybe this design must be changed.

Any object could be analyzed by me.!

!FLDefaultAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 10/26/2010 10:24'!
analyzes: anObject

	^ true! !

!FLDefaultAnalyzer methodsFor: 'evaluating' stamp: 'MartinDias 10/20/2010 15:40'!
value: anObject

	anObject fuelAccept: self! !

!FLDefaultAnalyzer methodsFor: 'visiting' stamp: 'MartinDias 10/26/2010 10:17'!
visitClassOrTrait: aClassOrTrait
	"Visits a Class or a Trait that should be fully serialized."
	
	self shouldBeImplemented ! !

!FLDefaultAnalyzer methodsFor: 'visiting' stamp: 'MartinDias 11/12/2010 16:10'!
visitMetaclass: aMetaclass

	analyzer  
		clusters: analyzer clusteredBaselevelObjects 
		add: aMetaclass! !

!FLDefaultAnalyzer methodsFor: 'visiting' stamp: 'MartinDias 11/11/2010 16:12'!
visitNilTrueFalse: anObject
	"Visits these singleton objects. They has a special treatment because they are so common. And also nil is special because it cannot be added to a Set like the other objects."

	analyzer 
		clusters: analyzer clusteredBaselevelObjects 
		add: anObject 
		serializer: anObject fuelSerializer 
		collectionFactoryBlock: [ OrderedCollection new ]! !

!FLDefaultAnalyzer methodsFor: 'visiting' stamp: 'MartinDias 11/11/2010 16:11'!
visitObject: anObject
	"Visits an object in the most generic way"

	analyzer
		clusters: analyzer clusteredBaselevelObjects
		add: anObject! !

!FLDefaultAnalyzer methodsFor: 'visiting' stamp: 'MartinDias 11/11/2010 14:22'!
visitPrimitive: anObject
	"Visits the objects who do not depend on others"

	analyzer 
		clusters: analyzer clusteredBaselevelObjects 
		add: anObject! !

FLObjectAnalyzer subclass: #FLGlobalAnalyzer
	instanceVariableNames: ''
	classVariableNames: 'GlobalObjects'
	poolDictionaries: ''
	category: 'Fuel-Core-Analyzer'!

!FLGlobalAnalyzer commentStamp: '<historical>' prior: 0!
I analyze classes and well known objects that belong to Smalltalk global dictionary.

For example, Transcript is analyzed by me.!

!FLGlobalAnalyzer classSide methodsFor: 'class initialization' stamp: 'MarianoMartinezPeck 12/2/2010 15:44'!
classAdded: anEvent

	GlobalObjects add: anEvent item

! !

!FLGlobalAnalyzer classSide methodsFor: 'class initialization' stamp: 'MarianoMartinezPeck 12/2/2010 15:31'!
classRemoved: anEvent

	GlobalObjects 
		remove: anEvent item
		ifAbsent: [ ]! !

!FLGlobalAnalyzer classSide methodsFor: 'accessing' stamp: 'MartinDias 11/25/2010 16:16'!
globalNames

	^ #(#Display #World #Smalltalk #Transcript #SourceFiles #Processor #ImageImports #TextConstants #Undeclared #SystemOrganization #Sensor #ActiveWorld)! !

!FLGlobalAnalyzer classSide methodsFor: 'accessing' stamp: 'MartinDias 11/25/2010 16:00'!
globalObjects

	^ GlobalObjects! !

!FLGlobalAnalyzer classSide methodsFor: 'class initialization' stamp: 'MartinDias 11/25/2010 16:17'!
initialize

	super initialize.
	self initializeGlobalObjects.
	self initializeListeners.
! !

!FLGlobalAnalyzer classSide methodsFor: 'class initialization' stamp: 'MartinDias 11/25/2010 16:16'!
initializeGlobalObjects

	GlobalObjects := (Smalltalk allClassesAndTraits asIdentitySet)
		addAll: (self globalNames collect: [ :key | Smalltalk globals at: key ]);
		yourself! !

!FLGlobalAnalyzer classSide methodsFor: 'class initialization' stamp: 'MartinDias 11/25/2010 16:30'!
initializeListeners

	self flag: #todo. "unregistrer? anocher better way of doing this?"

	SystemChangeNotifier uniqueInstance 
		notify: self
			ofSystemChangesOfItem: #class
			change: #Removed
			using: #classRemoved:;
		notify: self
			ofSystemChangesOfItem: #class
			change: #Added
			using: #classAdded:! !

!FLGlobalAnalyzer methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/22/2010 21:09'!
analyzes: anObject

	^ self class globalObjects includes: anObject! !

!FLGlobalAnalyzer methodsFor: 'evaluating' stamp: 'MartinDias 10/20/2010 15:40'!
value: anObject

	anObject fuelAccept: self! !

!FLGlobalAnalyzer methodsFor: 'visiting' stamp: 'MartinDias 11/11/2010 21:02'!
visitClassOrTrait: aClassOrTrait

	analyzer  
		clusters: analyzer clusteredMetalevelObjects 
		add: aClassOrTrait 
		serializer: FLReferencedClassClusterSerializer instance! !

!FLGlobalAnalyzer methodsFor: 'visiting' stamp: 'MartinDias 11/11/2010 20:05'!
visitObject: anObject

	analyzer 
		clusters: analyzer clusteredMetalevelObjects
		add: anObject  
		serializer: FLGlobalClusterSerializer instance! !

FLObjectAnalyzer subclass: #FLGlobalAssociationAnalyzer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Analyzer'!

!FLGlobalAssociationAnalyzer commentStamp: '<historical>' prior: 0!
I analyze variable bindings that belong to Smalltalk global dictionary.

For example, 

	Smalltalk globals associationAt: #Transcript 
	
is analyzed by me.!

!FLGlobalAssociationAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 10/26/2010 10:24'!
analyzes: anObject

	^ anObject isVariableBinding and: [Smalltalk globals includesAssociation: anObject ].
! !

!FLGlobalAssociationAnalyzer methodsFor: 'evaluating' stamp: 'MartinDias 11/11/2010 16:10'!
value: anObject

	analyzer 
		clusters: analyzer clusteredMetalevelObjects
		add: anObject  
		serializer: FLGlobalAssociationClusterSerializer instance! !

!FLObjectAnalyzer classSide methodsFor: 'instance creation' stamp: 'MartinDias 10/20/2010 15:46'!
newWith: anAnalyzer

	^ self basicNew
		initialize;
		analyzer: anAnalyzer;
		yourself! !

!FLObjectAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 10/20/2010 15:42'!
analyzer
	^ analyzer! !

!FLObjectAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 10/20/2010 15:42'!
analyzer: anObject
	analyzer := anObject! !

!FLObjectAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 10/26/2010 10:23'!
analyzes: anObject
	"Tells if the received object is handled by this analyzer"

	self subclassResponsibility ! !

!FLObjectAnalyzer methodsFor: 'evaluating' stamp: 'MartinDias 10/25/2010 15:20'!
value: anObject
	"Executes the analysis on the object received."

	self subclassResponsibility ! !

Object subclass: #FLPair
	instanceVariableNames: 'left right'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Tests'!

!FLPair methodsFor: 'comparing' stamp: 'MartinDias 10/15/2010 10:54'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ self right = anObject right and: [ self left = anObject left ]! !

!FLPair methodsFor: 'comparing' stamp: 'MartinDias 10/15/2010 10:54'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ self right hash bitXor: self left hash! !

!FLPair methodsFor: 'accessing' stamp: 'MartinDias 9/16/2010 19:58'!
left
	^ left! !

!FLPair methodsFor: 'accessing' stamp: 'MartinDias 9/16/2010 19:58'!
left: anObject
	left := anObject! !

!FLPair methodsFor: 'accessing' stamp: 'MartinDias 9/16/2010 19:58'!
right
	^ right! !

!FLPair methodsFor: 'accessing' stamp: 'MartinDias 9/16/2010 19:58'!
right: anObject
	right := anObject! !

Object subclass: #FLSerializer
	instanceVariableNames: 'stream instanceIndexes referenceSerializingActions integerSerializer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core'!

!FLSerializer commentStamp: '<historical>' prior: 0!
I am a binary object serializer. 

By sending me #serializeAll: with a collection of objects as argument, I will write them on a byte stream, such that later a FLMaterializer instance will be able to read the stream and recreate the objects in the same or another image.!

!FLSerializer class methodsFor: 'instance creation' stamp: 'sd 9/8/2010 14:59'!
on: aWriteStream

	| serializer |
	serializer := self new.
	serializer stream: aWriteStream.
	^serializer.! !

!FLSerializer methodsFor: 'initialize-release' stamp: 'MartinDias 10/4/2010 22:48'!
initialize 

	instanceIndexes := IdentityDictionary new.
	referenceSerializingActions := OrderedCollection new.! !

!FLSerializer methodsFor: 'accessing' stamp: 'MartinDias 9/27/2010 14:53'!
nextPutInteger: anInteger

	integerSerializer serialize: anInteger on: stream! !

!FLSerializer methodsFor: 'accessing' stamp: 'MartinDias 9/27/2010 14:52'!
nextPutReferenceTo: anObject

	integerSerializer serialize: (instanceIndexes at: anObject) on: stream! !

!FLSerializer methodsFor: 'private' stamp: 'MartinDias 11/25/2010 12:34'!
nextPutSerializerId: id

	stream nextPut: id! !

!FLSerializer methodsFor: 'accessing' stamp: 'MartinDias 10/15/2010 10:47'!
referenceSerializingActionsAdd: aBlock
	"Adds an action for being valued at the references serializing step"
	
	referenceSerializingActions add: aBlock ! !

!FLSerializer methodsFor: 'serializing' stamp: 'MartinDias 11/3/2010 15:28'!
serialize: anObject 
	"Serializes using the default analyzer"

	self serialize: anObject analyzer: FLAnalyzer newDefault! !

!FLSerializer methodsFor: 'serializing' stamp: 'MartinDias 11/3/2010 15:29'!
serialize: anObject analyzer: anAnalyzer
	"Main message for serializing"

	| objectCount clusteredObjects |
	anAnalyzer analyze: anObject.

	clusteredObjects := anAnalyzer clusteredObjects.
	objectCount := anAnalyzer objectCount.
	integerSerializer := objectCount fuelSerializer.

	self serializeHeaderWith: clusteredObjects and: objectCount.
	self serializeInstances: clusteredObjects.
	self serializeReferences.
	self serializeRoot: anObject.
! !

!FLSerializer methodsFor: 'private' stamp: 'MartinDias 2/26/2011 04:23'!
serializeHeaderWith: clusteredObjects and: objectCount

	self nextPutSerializerId: integerSerializer class id.
	self nextPutInteger: objectCount.
	self nextPutInteger: clusteredObjects size! !

!FLSerializer methodsFor: 'private' stamp: 'MartinDias 11/25/2010 19:14'!
serializeInstances: clusteredInstances

	clusteredInstances
		do: [ :anAssociation | 
			| serializer instances |
			serializer := anAssociation key.
			instances := anAssociation value.

			self nextPutSerializerId: serializer class id.
			serializer serializeAll: instances with: self.
			instances do: [ :instance | instanceIndexes at: instance put: instanceIndexes size + 1 ] ]! !

!FLSerializer methodsFor: 'private' stamp: 'MartinDias 9/11/2010 19:04'!
serializeReferences

	referenceSerializingActions 
		do: [ :aBlock | aBlock value ]! !

!FLSerializer methodsFor: 'private' stamp: 'MartinDias 10/28/2010 10:36'!
serializeRoot: anObject

	self nextPutReferenceTo: anObject! !

!FLSerializer methodsFor: 'accessing' stamp: 'sd 9/8/2010 14:59'!
stream
	^ stream! !

!FLSerializer methodsFor: 'accessing' stamp: 'sd 9/8/2010 14:59'!
stream: anObject
	stream := anObject! !

FLSerializer subclass: #FLTestSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Tests'!

FLTestSerializer class
	instanceVariableNames: 'version'!

FLTestSerializer class
	instanceVariableNames: 'version'!

!FLTestSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 11/25/2010 18:58'!
version

	^ version! !

!FLTestSerializer classSide methodsFor: 'accessing' stamp: 'MartinDias 11/25/2010 18:58'!
version: aVersion

	version := aVersion! !

!Object methodsFor: '*Fuel' stamp: 'MartinDias 9/27/2010 16:49'!
fuelAccept: aVisitor

	aVisitor visitObject: self.
! !

!Object methodsFor: '*Fuel' stamp: 'MartinDias 9/24/2010 01:36'!
fuelSerializer

	^ FLObjectClusterSerializer for: self class! !

!WordArrayForSegment methodsFor: '*Fuel' stamp: 'MartinDias 12/2/2010 13:23'!
fuelSerializer

	^ FLWordArrayForSegmentClusterSerializer instance.! !
FLClassPoolAssociationAnalyzer initialize!
FLClusterSerializer initialize!
FLGlobalAnalyzer initialize!
FLNilTrueFalseClusterSerializer initialize!
